#!/usr/bin/perl

@Layer;
@SubLayer;
@DetType;
@PosX;
@PosY;
@PosZ;
@SizX;
@SizY;
@SizZ;
@RotAngleX;
@RotAngleY;
@RotAngleZ;

# Plastic size of  Neut and Veto
$Siz_n_x = 50;
$Siz_n_y = 2500;
$Siz_n_z = 50;
$Siz_v_x = 500;
$Siz_v_y = 2500;
$Siz_v_z = 10;

$NeutNumSubLayer = 50;
$VetoNumLayer = 5;
$NeutIDCenter = 25.5;
$VetoIDCenter = 3.0;
$DistLayer = 1000;
$DistVetoNeut = 100;
$DistNeutNeutX = 0.0;
$DistNeutNeutZ = 0.0;
$DistVetoVetoZ = 15;
$VetoOverWrapX = 0.0;

$WholeShiftX = 0;
$WholeShiftY = 0;
$WholeShiftZ = 0;
$NeutWholeShiftZ = 0;

$IDsta=201;
$IDsto=605;
$ID=$IDsta;
$iSubLayerSeq=1;

#NeuLAND Neutron Detector (ID=201:600)
while($iSubLayerSeq<9){
    for ($ineut=1;$ineut<=$NeutNumSubLayer;++$ineut){
	$Layer[$ID] = ($iSubLayerSeq+3)/4;
	$Layer[$ID] = int $Layer[$ID];
	$SubLayer[$ID] = ($iSubLayerSeq+3)%4+1;
	$DetType[$ID] = "NeuLAND";
	$PosX[$ID] = -($ineut-$NeutIDCenter)*($Siz_n_x+$DistNeutNeutX);
	$PosY[$ID] = 0;
	$PosZ[$ID] = ($Layer[$ID]-1)*$DistLayer;
	$PosZ[$ID] += $Siz_n_z * ($SubLayer[$ID]-1);
	$SizX[$ID] = $Siz_n_x;
	$SizY[$ID] = $Siz_n_y;
	$SizZ[$ID] = $Siz_n_z;
	if ($SubLayer[$ID]%2==1) {
	    $tmp = $PosX[$ID];
	    $PosX[$ID] = $PosY[$ID];
	    $PosY[$ID] = $tmp;
	    $tmp = $SizX[$ID];
	    $SizX[$ID] = $SizY[$ID];
	    $SizY[$ID] = $tmp;
	    $RotAngleZ[$ID]=90;
	}

	$ID++;
    }
    $iSubLayerSeq++;
}

#for Veto Detector (ID=601, 605)
$iLayer = 1;
while($iLayer<3){
    for ($iveto=1;$iveto<=$VetoNumLayer;++$iveto){
	$Layer[$ID]  = $iLayer;
	$Sublayer[$ID] = 0;
	$DetType[$ID] = "NeuLANDVeto";
	$PosX[$ID] = -($iveto-$VetoIDCenter)*($Siz_v_x-$VetoOverWrapX);
	$PosY[$ID] = 0;
	$PosZ[$ID] = ($iLayer-1)*$DistLayer - $DistVetoNeut;
	if ($ID%2==1) {$PosZ[$ID] -= $DistVetoVetoZ;}
	$SizX[$ID] = $Siz_v_x;
	$SizY[$ID] = $Siz_v_y;
	$SizZ[$ID] = $Siz_v_z;
	$ID++;
    }
    $iLayer++;
}

for ($i=$IDsta;$i<$IDsto+1;++$i){
    $PosX[$i] += $WholeShiftX;
    $PosY[$i] += $WholeShiftY;
    $PosZ[$i] += $WholeShiftZ;
}

print "ID, DetectorType, Layer, SubLayer, PositionX, PositionY, PositionZ, AngleX, AngleY, AngleZ,\n";
for ($i=$IDsta;$i<$IDsto+1;++$i){
    printf("%3i, %s, %2i, %2i, %7.2f, %7.1f, %7.1f, %5.1f, %5.1f, %5.1f,\n",
	   $i,$DetType[$i], $Layer[$i],$SubLayer[$i],
	   $PosX[$i],$PosY[$i],$PosZ[$i],
	   $RotAngleX[$i],$RotAngleY[$i],$RotAngleZ[$i]
	);
}
