#include <iostream>

#include "TFile.h"
#include "TTree.h"
#include "TVector3.h"
#include "TMath.h"

#include "TFragSimData.hh"
#include "TRunSimParameter.hh"
#include "TFragSimParameter.hh"

void calc_fdc2pos(TString filename="root/storage/trajectories_0000.root")
{

  TFile *file = new TFile(filename.Data());

//  TRunSimParameter *RunPrm = 0;
//  file->GetObject("RunParameter",RunPrm);
//  RunPrm->Print();

  TFragSimParameter *FragPrm = 0;
  file->GetObject("FragParameter",FragPrm);
//  FragPrm->Print();

  Double_t FDC2Angle = FragPrm->fFDC2Angle;
  TVector3 posFDC2  = FragPrm->fFDC2Position;
//  cout<<"FDC2pos"<<endl;
//  posFDC2.Print();
//  cout<<"FDC2ang="<<FDC2Angle<<endl;

  Double_t HODAngle = FragPrm->fHODAngle;
  TVector3 posHOD  = FragPrm->fHODPosition;
//  cout<<"HODpos"<<endl;
//  posHOD.Print();
//  cout<<"HODang="<<HODAngle<<endl;

  TTree *tree = (TTree*)file->Get("tree");
  tree->SetBranchAddress("fragment",&gFragSimDataArray);  

  Int_t neve = tree->GetEntries();
  for (Int_t ieve=0;ieve<neve;++ieve){
    gFragSimDataArray->clear();
    tree->GetEntry(ieve);

    // Get fragment data
    Bool_t OK_FDC2    = false;
    Bool_t OK_HODF    = false;
    Int_t nfrag = gFragSimDataArray->size();
    cout<<"i="<<ieve<<"   ";
    for (Int_t ifrag=0;ifrag<nfrag;++ifrag){
      TFragSimData frag = (*gFragSimDataArray)[ifrag];
      //-----------------------------------------
      if (frag.fDetectorName == "FDC2") {
	OK_FDC2 = true;
	TVector3 pos = frag.fPrePosition;
	TVector3 pos_cpy = pos-posFDC2;
	pos_cpy.RotateY(-FDC2Angle/180.*TMath::Pi());
	//pos_cpy.Print();
	cout<<frag.fParticleName<<"   ";
	printf("x@FDC2 = % -5.0fmm  ",pos_cpy.x());
	
      //-----------------------------------------
      }else if (frag.fDetectorName == "HOD") {
	OK_HODF = true;
	TVector3 pos = frag.fPrePosition;
	TVector3 pos_cpy = pos-posHOD;
	pos_cpy.RotateY(-FDC2Angle/180.*TMath::Pi());
	//pos_cpy.Print();
	printf("x@HOD = % -5.0fmm  ",pos_cpy.x());
      }
      //-----------------------------------------
    }//for (Int_t ifrag=0;ifrag<nfrag;++ifrag){
    cout<<endl;

  }
}
