void plot_eff(){
  TFile *fileout = new TFile("root/plot_eff.root","recreate");
  fileout->cd();
  TGraph *g2 = plot_eff_i(2);
  TGraph *g3 = plot_eff_i(3);
  TGraph *g4 = plot_eff_i(4);
  TGraph *g6 = plot_eff_i(6);

  g2->SetName("geff2");
  g3->SetName("geff3");
  g4->SetName("geff4");
  g6->SetName("geff6");

  g2->GetYaxis()->SetRangeUser(0,0.5);
  g3->GetYaxis()->SetRangeUser(0,0.5);
  g4->GetYaxis()->SetRangeUser(0,0.5);
  g6->GetYaxis()->SetRangeUser(0,0.5);

  g2->SetLineColor(2);
  g3->SetLineColor(3);
  g4->SetLineColor(4);
  g6->SetLineColor(6);

  g2->SetMarkerColor(2);
  g3->SetMarkerColor(3);
  g4->SetMarkerColor(4);
  g6->SetMarkerColor(6);

  g2->Draw("LAP*");
  g3->Draw("LP*same");
  g4->Draw("LP*same");
  g6->Draw("LP*same");
  fileout->Add(g2);
  fileout->Add(g3);
  fileout->Add(g4);
  fileout->Add(g6);
  fileout->Write();

}


TGraph* plot_eff_i(Int_t isetup=2){

  const Int_t N=10;
  Double_t erel[N]={0.5,1,2,3,4,5,6,7,8,9};
  Double_t eff[N]={0,0,0,0,0, 0,0,0,0,0};
  for (int irun=0;irun<8;irun++){
    stringstream ss;
    ss<<"root/analyzed_samurai21_"<<isetup<<"_28o_seq_4n_000"<<irun<<".root";
    TFile *file = new TFile(ss.str().c_str(),"readonly");
    TH1* h=(TH1*)file->Get("herel_duct");
    //TH1* h=(TH1*)file->Get("herel");
    Int_t counts = h->Integral();

    // temp
    TH1 *hokduct=(TH1*)file->Get("hokduct");
    Double_t acc_duct = hokduct->GetMean();
    //

    eff[irun] = (Double_t)counts/100000.*100;


  }


//  TGraph *g = new TGraph(N,erel,eff);
  TGraph *g = new TGraph(8,erel,eff);

  return g;
}
