void plot_eff_25o(){
  TFile *fileout = new TFile("root/plot_eff_25o.root","recreate");
  fileout->cd();
  TGraph *g2 = plot_eff_25o_i(2);
  TGraph *g6 = plot_eff_25o_i(6);

  g2->SetName("geff2");
  g6->SetName("geff6");

  g2->SetTitle("25O->24O+n setup2");
  g6->SetTitle("25O->24O+n setup6");

  g2->GetYaxis()->SetRangeUser(0,60);
  g6->GetYaxis()->SetRangeUser(0,60);

  g2->GetXaxis()->SetTitle("Erel (MeV)");
  g6->GetXaxis()->SetTitle("Erel (MeV)");

  g2->GetYaxis()->SetTitle("Efficiency (%)");
  g6->GetYaxis()->SetTitle("Efficiency (%)");


  g2->SetLineColor(2);
  g6->SetLineColor(6);

  g2->SetMarkerColor(2);
  g6->SetMarkerColor(6);

  g2->Draw("LAP*");
  g6->Draw("LP*same");
  fileout->Add(g2);
  fileout->Add(g6);
  fileout->Write();

}


TGraph* plot_eff_25o_i(Int_t isetup=2){

  const Int_t N=10;
  const Int_t Nplot=8;
  Double_t erel[N]={0.5,1,2,3,4,5,6,7,8,9};
  Double_t eff[N]={0,0,0,0,0, 0,0,0,0,0};
  for (int irun=0;irun<Nplot;irun++){
    stringstream ss;
    ss<<"root/analyzed_samurai21_"<<isetup<<"_25o_ps_1n_000"<<irun<<".root";
    TFile *file = new TFile(ss.str().c_str(),"readonly");
    TH1* h=(TH1*)file->Get("herel_duct");
    //TH1* h=(TH1*)file->Get("herel");
    Int_t counts = h->Integral();

    // temp
    TH1 *hokduct=(TH1*)file->Get("hokduct");
    Double_t acc_duct = hokduct->GetMean();
    //

    if (isetup==6)
      eff[irun] = (Double_t)counts/10000.*100;
    else
      eff[irun] = (Double_t)counts/100000.*100;
      

  }


  TGraph *g = new TGraph(Nplot,erel,eff);

  return g;
}
