void plot_eff_27o(){
  TFile *fileout = new TFile("root/plot_eff_27o.root","recreate");
  fileout->cd();
  TGraph *g2 = plot_eff_27o_i(2);
  TGraph *g3 = plot_eff_27o_i(3);
  TGraph *g4 = plot_eff_27o_i(4);
  TGraph *g5 = plot_eff_27o_i(5);

  g2->SetName("geff2");
  g3->SetName("geff3");
  g4->SetName("geff4");
  g5->SetName("geff5");

  g2->SetTitle("27O->24O+3n setup2");
  g3->SetTitle("27O->24O+3n setup3");
  g4->SetTitle("27O->24O+3n setup4");
  g5->SetTitle("27O->24O+3n setup5");

  g2->GetYaxis()->SetRangeUser(0,3);
  g3->GetYaxis()->SetRangeUser(0,3);
  g4->GetYaxis()->SetRangeUser(0,3);
  g5->GetYaxis()->SetRangeUser(0,3);

  g2->GetXaxis()->SetTitle("Erel (MeV)");
  g3->GetXaxis()->SetTitle("Erel (MeV)");
  g4->GetXaxis()->SetTitle("Erel (MeV)");
  g5->GetXaxis()->SetTitle("Erel (MeV)");

  g2->GetYaxis()->SetTitle("Efficiency (%)");
  g3->GetYaxis()->SetTitle("Efficiency (%)");
  g4->GetYaxis()->SetTitle("Efficiency (%)");
  g5->GetYaxis()->SetTitle("Efficiency (%)");


  g2->SetLineColor(2);
  g3->SetLineColor(3);
  g4->SetLineColor(4);
  g5->SetLineColor(5);

  g2->SetMarkerColor(2);
  g3->SetMarkerColor(3);
  g4->SetMarkerColor(4);
  g5->SetMarkerColor(5);

  g2->Draw("LAP*");
  g3->Draw("LP*same");
  g4->Draw("LP*same");
  g5->Draw("LP*same");
  fileout->Add(g2);
  fileout->Add(g3);
  fileout->Add(g4);
  fileout->Add(g5);
  fileout->Write();

}


TGraph* plot_eff_27o_i(Int_t isetup=2){

  const Int_t N=10;
  const Int_t Nplot=8;
  Double_t erel[N]={0.5,1,2,3,4,5,6,7,8,9};
  Double_t eff[N]={0,0,0,0,0, 0,0,0,0,0};
  for (int irun=0;irun<Nplot;irun++){
    stringstream ss;
    ss<<"root/analyzed_samurai21_"<<isetup<<"_27o_seq_3n_000"<<irun<<".root";
    TFile *file = new TFile(ss.str().c_str(),"readonly");
    TH1* h=(TH1*)file->Get("herel_duct");
    //TH1* h=(TH1*)file->Get("herel");
    Int_t counts = h->Integral();

    // temp
    TH1 *hokduct=(TH1*)file->Get("hokduct");
    Double_t acc_duct = hokduct->GetMean();
    //

    eff[irun] = (Double_t)counts/100000.*100;


  }


  TGraph *g = new TGraph(Nplot,erel,eff);

  return g;
}
