void plot_eff_all(){
  TFile *fileout = new TFile("root/plot_eff_all.root","recreate");
  fileout->cd();
  TGraph *g25 = plot_eff_i("root/analyzed_samurai21_2_25o_ps_1n");
  TGraph *g26 = plot_eff_i("root/analyzed_samurai21_2_26o_ps_2n");
  TGraph *g27 = plot_eff_i("root/analyzed_samurai21_2_27o_seq_3n");
  TGraph *g28 = plot_eff_i("root/analyzed_samurai21_2_28o_seq_4n");

  g25->SetName("geff25");
  g26->SetName("geff26");
  g27->SetName("geff27");
  g28->SetName("geff28");

  g25->SetTitle("25O phase space decay (24O+n)");
  g26->SetTitle("26O phase space decay (24O+2n)");
  g27->SetTitle("27O sequential decay (24O+3n)");
  g28->SetTitle("28O sequential decay (24O+4n)");
  g25->GetXaxis()->SetTitle("Erel (MeV)");
  g26->GetXaxis()->SetTitle("Erel (MeV)");
  g27->GetXaxis()->SetTitle("Erel (MeV)");
  g28->GetXaxis()->SetTitle("Erel (MeV)");
  g25->GetYaxis()->SetTitle("Efficiency (%)");
  g26->GetYaxis()->SetTitle("Efficiency (%)");
  g27->GetYaxis()->SetTitle("Efficiency (%)");
  g28->GetYaxis()->SetTitle("Efficiency (%)");

  g25->GetXaxis()->SetRangeUser(0,8);
  g26->GetXaxis()->SetRangeUser(0,8);
  g27->GetXaxis()->SetRangeUser(0,8);
  g28->GetXaxis()->SetRangeUser(0,8);

  g25->GetYaxis()->SetRangeUser(0,100);
  g26->GetYaxis()->SetRangeUser(0,30);
  g27->GetYaxis()->SetRangeUser(0,3);
  g28->GetYaxis()->SetRangeUser(0,0.8);

  if (gPad==0) new TCanvas;
  c1->Clear();
  c1->Divide(2,2);
  c1->cd(1);
  g25->Draw("LAP*");
  c1->cd(2);
  g26->Draw("LAP*");
  c1->cd(3);
  g27->Draw("LAP*");
  c1->cd(4);
  g28->Draw("LAP*");

  fileout->Add(g25);
  fileout->Add(g26);
  fileout->Add(g27);
  fileout->Add(g28);
  fileout->Write();

}


TGraph* plot_eff_i(TString filename="root/analyzed_samurai21_2_28o_seq_4n"){

  const Int_t N=10;
  const Int_t Nuse=8;
  Double_t erel[N]={0.5,1,2,3,4,5,6,7,8,9};
  Double_t eff[N]={0,0,0,0,0, 0,0,0,0,0};
  for (int irun=0;irun<Nuse;irun++){
    stringstream ss;
    ss<<filename.Data()<<"_000"<<irun<<".root";
    TFile *file = new TFile(ss.str().c_str(),"readonly");
    TH1* h=(TH1*)file->Get("herel_duct");
    //TH1* h=(TH1*)file->Get("herel");
    Int_t counts = h->Integral();

    // temp
    TH1 *hokduct=(TH1*)file->Get("hokduct");
    Double_t acc_duct = hokduct->GetMean();
    //

    eff[irun] = (Double_t)counts/100000.*100;

  }


//  TGraph *g = new TGraph(N,erel,eff);
  TGraph *g = new TGraph(Nuse,erel,eff);

  return g;
}
