void plot_yok(TString RunName="25o_ps_1n",TString HistName="hoky60",
	      TString opt="LAP*")
{
  TGraph *g2 = plot_acc_i(RunName,HistName);
  g2->SetName("geff2");
  g2->SetTitle(RunName);
  g2->GetYaxis()->SetRangeUser(0,100.);
  g2->GetXaxis()->SetTitle("Erel (MeV)");
  g2->GetYaxis()->SetTitle("Y Acceptance (%)");
  g2->Draw(opt.Data());
}


TGraph* plot_acc_i(TString RunName,TString HistName){

  const Int_t N=10;
  Double_t erel[N]={0.5,1,2,3,4,5,6,7,8,9};
  Double_t eff[N]={0,0,0,0,0, 0,0,0,0,0};
  for (int irun=0;irun<8;irun++){
    stringstream ss;
    ss<<"root/analyzed_samurai21_2_"<<RunName.Data()<<"_000"<<irun<<".root";
    TFile *file = new TFile(ss.str().c_str(),"readonly");
    TH1 *hok=(TH1*)file->Get(HistName.Data());
    Double_t acc = hok->GetMean();

    eff[irun] = (Double_t)acc*100;
    cout<<"run="<<irun<<" eff="<<eff[irun]<<"%"<<endl;

  }

  TGraph *g = new TGraph(8,erel,eff);

  return g;
}
